%% Ein einfaches inverses Problem
A=[1 3 
   2 4];

%für diese Matrix wird es plötzlich nicht mehr so einfach...
  A=[1 2 
     2 4.1];


% Originaldaten: 
p =[2; 5];

% Bildpunkt
q = A*p

% und jetzt umgekehrt:
% gegeben q, was war der Ausgangswert p?
% Die q-Daten sind allerdings ein bisserl verrauscht...
q_gestoert = q + 0.1*randn(2,100);

% wodurch die rekonstruierten p-Werte auch gestört sind
p_gestoert = A\q_gestoert;

plot(q_gestoert(1,:),q_gestoert(2,:),'or',p_gestoert(1,:),p_gestoert(2,:),'ob')
axis equal
title({'rot: Bildpunkte, gestört','Blau: daraus rekonstruierte Ausgangswerte'})

%% regularisierte Lösung: 
% löse das System der Normalengleichungen mit ein klein wenig
% Einheitsmatrix dazu:
% (A^T A + alpha I) p  = A^T q 
%
alpha=0.1;
p_reg = (A'*A+alpha*eye(2))\A'*q_gestoert;
plot(q_gestoert(1,:),q_gestoert(2,:),'or',p_gestoert(1,:),p_gestoert(2,:),'ob',p_reg(1,:),p_reg(2,:),'og')
title({'rot: Bildpunkte, gestört','Blau: rekonstruierte Ausgangswerte','Grün: regularisierte Ausgangswerte'})
grid on
axis equal
 

%% regularisierte Lösung, Rechenweg über SVD 
% für tieferes Verständnis und weitereführende Arbeit ist SVD notwendig.
% Als Kochrezept ist der Rechenweg über Normalengleichungen vielleicht
% einfacher. 

[U, S, V]=svd(A);
alpha=0.1;
Sreg=zeros(size(S));
Sreg=diag(diag(S)./(diag(S).^2 + alpha));
p_regSVD = V*Sreg*U'*q_gestoert;

%Ergebnisse bis auf kleine Rundungsfehler ident.
norm(p_reg-p_regSVD)
 



